<?php


/*
всякий раз когда происходит редактирование или добавление записи
сбрасывается кеш группы 'ads'
*/
add_action('save_post','ads_clear_cache');
function ads_clear_cache(){
    global $wp_object_cache;
    if( $wp_object_cache->cache['ads'] )
        unset( $wp_object_cache->cache['ads'] );
    else
        $wp_object_cache->flush();
}

// добавляем поля с adp_
function ads_table_fields($data,$postarr){
    foreach ($postarr as $key=>$value) {
      if( strpos($key,'adp_')===0 ) {
        if(is_array($value))
            $data[$key] = implode(',',$value);
        else
            $data[$key] = $value;
      }
    }
  return $data;
}

/*
	проверка типа файла в соответствии с заданными настройками
*/
function ads_check_type_file($type_file){
	global $ads_options;
	$ads_file_types = $ads_options['ads_file_types'];
	if(!sizeof($ads_options)) return false;
	$patern = '~^('.implode('|',$ads_file_types).')/[^\s]+$~';
	return preg_match($patern,$type_file);
}

function ads_get_category_parents($id, $separator = '/',$link = 1){
    $permalink = get_permalink();
    $cat_path = ads_get_parents_id( $id );
    if(sizeof($cat_path) <= 1) return '';

    while ( $cat = array_shift($cat_path) ) {
        $cat =  get_category($cat);
        if($link)
            $arr[] = '<a href="'.add_query_arg('ads_basecat', $cat->term_id ,$permalink).'">'.$cat->name.'</a>';
        else
            $arr[] = $cat->name;
    }
    $arr = array_reverse($arr);
    if($separator) return implode($separator, $arr);
    else  return $arr;


}

//   возращает ID родительских категорий
function ads_get_parents_id($id=''){
    global  $ads_options;
    $opt_basecat = $ads_options['ads_base_category'];
    if( $id == $opt_basecat) return array($id);
    if(!$id) $id = $_REQUEST['ads_basecat'];
     //clean_category_cache($id);
    $catecory = get_category($id);
	if ( is_wp_error( $catecory ) or !$catecory ){
		return '';
	}
    $result[] =  $catecory->term_id;
    if( $catecory->parent ) {
       $result = array_merge($result, ads_get_parents_id($catecory->parent) );
    }
    return $result;
}


function _ads_chield_line(&$categories,&$arr_line){
	foreach ($categories as $key=>$value) {
 		if(!isset($arr_line[$key])){
 			$arr_line[$key] = & $categories[$key];
 		}
 		if(isset($categories[$key]->sub_category)){
 			_ads_chield_line($categories[$key]->sub_category,$arr_line);
 		}
 	}
}

function ads_category_list($base_category = 0, $args = ''){
    global $ads_config, $ads_options;
    $opt_basecat = $ads_options['ads_base_category'];
    extract($ads_config, EXTR_SKIP);

    $defaults = array(
		'show_option_all' => '1', 'orderby' => 'name',
		'order' => 'ASC', 'show_last_update' => 0,
		'style' => 'list', 'show_count' => 0,
		'hide_empty' => 0, 'use_desc_for_title' => 1,
		'child_of' => 0, 'feed' => '', 'feed_type' => '',
		'feed_image' => '', 'exclude' => '', 'current_category' => 0,
		'hierarchical' => true, 'title_li' => __('Categories'),'fields' => 'all',
		'echo' => 1, 'depth' => 0
	);
    $r = wp_parse_args( $args, $defaults );
	$data = get_categories($r);

    if(sizeof($data)==1) return $form_templates['default'];
	if ( empty($data) ) return false;
	$categories = array();
    foreach ($data as $key=>$value) {
        clean_category_cache($value->term_id);
        $categories[$value->term_id] =  $value;

    }

   /*	while (list ($key, $val) = each ($data)) {
		 $categories[$val->term_id] =  $val;
 	}*/
    unset($data);
 	//ksort ($categories); // sorted by ID
	//  исключаем заданные рубрики
	if($ads_options['ads_exclude']) {
			$exclude = explode(',',$ads_options['ads_exclude']);
			foreach ($exclude as $key=>$value) {
   			unset($categories[$value]);
   		}
	}


	reset($categories);

	while (list ($key, $val) = each ($categories)) {
 		if ( $val->parent != 0 AND isset($categories[$val->parent]) ) {
		 	$categories[$val->parent]->chields += 1;
			 $categories[$val->parent]->sub_category[$key] = & $categories[$key];
		}
  	}

	//prune $opt_basecat basic categories that the guidance in options
	if((int)$opt_basecat){
		if(isset($categories[$opt_basecat]->sub_category)){
			$categories = $categories[$opt_basecat]->sub_category;
			foreach ($categories as $key=>$value)
				$categories[$key]->parent = 0;
			_ads_chield_line($categories,$categories);
		}
		elseif(isset($categories[$opt_basecat])){
			$base_category = $opt_basecat;
		}
		else {
			echo __("The paternal category is wrong chosen",'ads-wordpress')." = $opt_basecat!";
			return false;
		}
	};
   //	echo '<pre>'; print_r( $categories ); echo '</pre>';
	if(isset($base_category) and isset($categories[$base_category])){
			// проверяем есть или нет потомки у категории если есть выводим их
			if(isset($categories[$base_category]->sub_category)){
				$categories	= $categories[$base_category]->sub_category;
				foreach ($categories as $key=>$value)
	   				$categories[$key]->parent = 0;
   			} else  {
   			    unset($categories);
   				return $form_templates['default'];
            }
	};
    if($depth = sizeof( ads_get_parents_id($base_category) )) $depth--;

    return ads_print_walk($categories, $depth);
}


function ads_print_walk($categories, $depth=0,$parent=0){
        global $ads_config, $ads_options;
		$REQUEST_URI = $GLOBALS['HTTP_SERVER_VARS']['REQUEST_URI'];
		$url =  (strstr($REQUEST_URI,'?')) ?  $REQUEST_URI.'&amp;' : '?';
		$_get = $_GET;
		unset($_get['ads_basecat']);
		unset($_get['ADS_ACTION']); //http://wp29/?page_id=6&ADS_ACTION=Array&ads_basecat=7
		foreach ($_get as $key=>$value) {
  		    $_get[$key] = "$key=$value";
  	    }
		$url = '?'.implode('&amp;',$_get);
		if($depth) $html = "<ul class='children ul-$depth parent-$parent'>";
		else $html = "<ul class = 'ads-category'>";
        reset($categories);
		while ( list ($key, $category ) = each ($categories)) {
    	   if ( (int)$depth == 0 AND (int)$category->parent != 0 )    continue;
           $html .= "<li class='cat-item cat-item-{$key} depth-$depth'>";
           $html .= "<a href='{$url}&amp;ads_basecat=$category->term_id' title = '".attribute_escape( apply_filters( 'category_description', $category->description, $category )) ."'>";
           $html .= $category->name.'</a>';
           if($ads_options['ads_desc_category']){
                $html .= '<div class="desc-category">'.$category->description.'</div>';
           }
           if($ads_options['ads_expand_category'] and sizeof($category->sub_category) ){
              if($ads_options['ads_depth_category'] == 0)
                $html .= ads_print_walk($category->sub_category, $depth+1,$parent=$category->term_id);
              elseif (($ads_options['ads_depth_category']-1) > $depth)
                $html .= ads_print_walk($category->sub_category, $depth+1,$parent=$category->term_id);

           }
           $html .= '</li>';
		}
		$html .= '</ul>';
		if($depth==0 ) $html .= HTML_SemiParser::makeCallbackIgnore();
		return $html;
}

// generates readable password
function genPassword($size = 8){
		$a = array('e','y','u','i','o','a');
    $b = array('q','w','r','t','p','s','d','f','g','h','j','k','l','z','x','c','v','b','n','m');
    $c = array('1','2','3','4','5','6','7','8','9','0');
    $password = $b[array_rand($b)];

    do {
        $lastChar = $password[ strlen($password)-1 ];
        @$predLastChar = $password[ strlen($password)-2 ];
        if( in_array($lastChar,$b) ) {
           if( in_array($predLastChar,$a) ) {
           	    $r = rand(0,2);
           	    if( $r  ) $password .= $a[array_rand($a)];
           	    else $password .= $b[array_rand($b)];
           }
           else $password .= $a[array_rand($a)];

        } else {
           if(rand(0,2))$password .= $b[array_rand($b)];
           else $password .= $c[array_rand($c)];
        }

    } while ( ($len = strlen($password) ) < $size);

    return $password;
}

function getip()
{
  if (getenv("HTTP_CLIENT_IP") && strcasecmp(getenv("HTTP_CLIENT_IP"),"unknown"))
    $ip = getenv("HTTP_CLIENT_IP");

  elseif (getenv("HTTP_X_FORWARDED_FOR") && strcasecmp(getenv("HTTP_X_FORWARDED_FOR"), "unknown"))
    $ip = getenv("HTTP_X_FORWARDED_FOR");

  elseif (getenv("REMOTE_ADDR") && strcasecmp(getenv("REMOTE_ADDR"), "unknown"))
    $ip = getenv("REMOTE_ADDR");

  elseif (!emptyempty($_SERVER['REMOTE_ADDR']) && strcasecmp($_SERVER['REMOTE_ADDR'], "unknown"))
    $ip = $_SERVER['REMOTE_ADDR'];

  else
    $ip = "";

  return($ip);
}