<?php


/*
Class ads_form_handler
 */
 class Ads_Form_Handler
{ // BEGIN class ads_form_handler
	// variables
	var $EDIT;  // флаг редактирования
	var $AdsFormEdit = false;   // флаг - мы на странице редактирования
  	var $wp_error;     // объект  WP_Error
  	var $ads_fields_form;
	var $name_template = false; // имя файла шаблона формы
	// constructor
    function ads_form_handler()
    { // BEGIN constructor

    } // END constructor
    /*
    	основной алгоритм обработчика
    */
    function ads_main($content)
    {
        // если нет тега <!--AdsForm-->  или <!--AdsFormEdit-->  выходим ничего не меняя
        if(! (is_page() or is_single() ) ) return $content;
        if(!preg_match('~<!--AdsForm(Edit)?-->~i',$content,$match)) return $content;
        $this->content = $content;
        if($match[1]) $this->AdsFormEdit = true; // форма редактирования
        // проверяем если включенна опция только для зарегистрированных пользователей
        if( $str = $this->check_user_status() ) return $content."\n <div id=\"not_form\">".$str.'</div>';
    	//  подготовка к запуску

    	$this->init();

    	//  отфильтровываем лишние поля
        $this->filter_fields_form();

    	// получаем значение кнопки Action
        $this->action = ($_POST['ADS_ACTION']) ? @key($_POST['ADS_ACTION']) : @key($_GET['ADS_ACTION']);
        //echo '<pre>'; print_r($this->action); echo '</pre>';
        global $user_ID, $ads_options;
    	switch ($this->action) {
            default:   //  Print form
                if($this->AdsFormEdit)
                    $this->login_form();
                else{
                        if(! $this->can_new_post() ){
                           $this->print_msg('no_new_post');
                        }else{
                            $this->print_form();
                        }

                    }
            break;
            case 'PARSE':
            case 'UPDATE':
            case 'PUBLISH':
            case 'SAVE':
                // если это новый пост проверяем можно ли создать его и выходим
                if(empty($_REQUEST['ID']) and !$this->can_new_post()){
                   $this->print_msg('no_new_post');
                   break;
                }
                //  проверяем каптчу
                if( !$this->check_captcha() ){
                    $this->print_form();
                    break;
                }

                $this->pre_format();
                if($this->check_form()){
                    $this->set_status();
                    $saved = $this->save_form();
                    $this->send_mail();
                }
                $this->upload();
                if($ads_options['ads_set_thumbnail']){
                    $this->set_thumbnail();
                }
                if ($saved) $this->print_msg('saved');
                $this->print_form();
            break;
            case 'EDIT':
            case 'LOGIN':
                if($this->ads_login()){
                    $this->load_data();
                    $this->print_form();
                }
                else
                    $this->login_form();
            break;
            case 'LOGIN_DELETE':
            case 'LOGIN_TO_TRASH':
                if($this->ads_login()){
                    $this->load_data();
                }
                else
                    $this->login_form();

            case 'DELETE':
            case 'TO_TRASH':
                if($this->can_delete()){
                    if($this->action == 'TO_TRASH' OR $this->action == 'LOGIN_TO_TRASH'
                        OR  ( ($ads_options['ads_overdue_category'] OR $ads_options['ads_overdue_metafield']) AND !current_user_can( 'edit_others_posts', $user_ID ) ) )
                        $this->to_trash();
                    else
                        $this->delete();
                }else{
                    $this->login_form();
                }
            break;

            case 'DELETE_FILE':
                if($this->can_delete()){
                	$this->file_delete();
    			}
                $this->set_draft();
                $this->print_msg('saved');
    			$this->print_form();
    		break;
    		case 'ROTATE_LEFT':
    		case 'ROTATE_RIGHT':
                if($this->can_delete()){
                	$this->file_rotate();
    			}
                $this->set_draft();
                $this->print_msg('saved');
    			$this->print_form();
    		break;
        }
        return $this->content;
    }


    /*
    	инициализация  данных массивов и переменных
    */
    function init()
    {

        include_once dirname(__FILE__).'/FormPersister.php';
        $arr = get_class_methods ('HTML_SemiParser');
        if(in_array('makeCallbackIgnore',$arr)) $this->action = -1;
    	// комбинируем массив-фильтр разрешонных полей
        $this->comb_fields_form();
        $this->wp_error = new WP_Error;
    	// получаем текущий шаблон формы
        $this->name_template = $this->category_template($_REQUEST['ads_basecat']);
        //подключаем шаюлон формы чтобы заработали локальные функции-фильтры
        // весь вывод прячем
        if( $this->name_template ){
          ob_start();
          global $ads_config;
          include $ads_config['dir_template'].$this->name_template;
          ob_end_clean();
        }
    }

    /*
    	предварительная обработка полей записи
    сначала форматируем потом проверяем
    */
    function pre_format(){
        global  $ads_options;
      // просто убираем переслеширование   блядь и удаляем hnml теги если надо  <b>afgaefasdfasd</b>
    	foreach ($_REQUEST as $key=>$value) {
    		if(is_string($value)){
    			$value =	@str_replace(array("\'",'\"'),array("'",'"'),$value);
                if(!$ads_options['ads_nostrip_tags']){
                    $value = strip_tags( $value, $ads_options['ads_strip_tags']);
                }
                $_REQUEST[$key] = $value;
    		}
    	}
        $_REQUEST['post_content'] = preg_replace('~([\w\dА-Яа-я])([\.\,\!\;\:\-\/\+\_]+)([\w\dА-Яа-я])~u','\1\2\3',$_REQUEST['post_content']);
        $_REQUEST['post_title'] = preg_replace('~([\w\dА-Яа-я])([\.\,\!\;\:\-\/\+\_]+)([\w\dА-Яа-я])~u','\1\2\3',$_REQUEST['post_title']);
    }
    /*
    	печатает кнопки управления
    	$return =0  print buttons
        $return = 1  return html text
    */
    function print_buttons($return = 0){
        global $user_ID, $ads_options;
        if(!$_REQUEST['post_status'] AND $_REQUEST['ID']){
    		$_REQUEST['post_status'] = get_post_status($_REQUEST['ID']);
    	}
        if(current_user_can( 'edit_others_posts', $user_ID ))
            if($_REQUEST['post_status'] == 'publish'){
                $html = "<input type=\"submit\" name=\"ADS_ACTION[UPDATE]\" value=\"".__('Update','ads-wordpress')."\" />";
                $html .= "<input type=\"submit\" name=\"ADS_ACTION[SAVE]\" value=\"".__('Save in draft','ads-wordpress')."\" />";
            }else{
                $html = "<input type=\"submit\" name=\"ADS_ACTION[PUBLISH]\" value=\"".__('Publish','ads-wordpress')."\" />";
                $html .= "<input type=\"submit\" name=\"ADS_ACTION[SAVE]\" value=\"".__('Save in draft','ads-wordpress')."\" />";
            }
        elseif( current_user_can( 'edit_posts', $user_ID ) )
            if($ads_options['ads_post_status'] == 'publish'){
                if($_REQUEST['post_status'] == 'publish'){
                    $html = "<input type=\"submit\" name=\"ADS_ACTION[UPDATE]\" value=\"".__('Update','ads-wordpress')."\" />";
                    $html .= "<input type=\"submit\" name=\"ADS_ACTION[SAVE]\" value=\"".__('Save in draft','ads-wordpress')."\" />";
                }else{
                    $html = "<input type=\"submit\" name=\"ADS_ACTION[PUBLISH]\" value=\"".__('Publish','ads-wordpress')."\" />";
                    $html .= "<input type=\"submit\" name=\"ADS_ACTION[SAVE]\" value=\"".__('Save in draft','ads-wordpress')."\" />";
                }
            }elseif($ads_options['ads_post_status'] == 'pending'){
                if($_REQUEST['post_status'] == 'pending' OR $_REQUEST['post_status'] == 'publish'){
                    $html = "<input type=\"submit\" name=\"ADS_ACTION[UPDATE]\" value=\"".__('Update','ads-wordpress')."\" />";
                    $html .= "<input type=\"submit\" name=\"ADS_ACTION[SAVE]\" value=\"".__('Save in draft','ads-wordpress')."\" />";
                }else{
                    $html = "<input type=\"submit\" name=\"ADS_ACTION[PUBLISH]\" value=\"".__('Send to moderation','ads-wordpress')."\" />";
                    $html .= "<input type=\"submit\" name=\"ADS_ACTION[SAVE]\" value=\"".__('Save in draft','ads-wordpress')."\" />";
                }
            }else{
                $html = "<input type=\"submit\" name=\"ADS_ACTION[SAVE]\" value=\"".__('Save in draft','ads-wordpress')."\" />";
            }

        else {
            if($ads_options['ads_post_status'] == 'publish')
                if($_REQUEST['post_status'] == 'publish')
                    $html = "<input type=\"submit\" name=\"ADS_ACTION[UPDATE]\" value=\"".__('Update','ads-wordpress')."\" />";
                else
                    $html = "<input type=\"submit\" name=\"ADS_ACTION[PUBLISH]\" value=\"".__('Publish','ads-wordpress')."\" />";
            elseif($ads_options['ads_post_status'] == 'pending')
                $html = "<input type=\"submit\" name=\"ADS_ACTION[PUBLISH]\" value=\"".__('Send to moderation','ads-wordpress')."\" />";
            else
                $html = "<input type=\"submit\" name=\"ADS_ACTION[SAVE]\" value=\"".__('Save in draft','ads-wordpress')."\" />";
        }


        if( $this->AdsFormEdit AND ($ads_options['ads_overdue_category'] OR $ads_options['ads_overdue_metafield'])) {
            $html .= "<input type=\"submit\" name=\"ADS_ACTION[TO_TRASH]\" value=\"".__('to Trash','ads-wordpress')."\" />";
            if(current_user_can( 'edit_others_posts', $user_ID )){
                $html .= "<input type=\"submit\" name=\"ADS_ACTION[DELETE]\" value=\"".__('Delete','ads-wordpress')."\" />";
            }
        }else{
            $html .= "<input type=\"submit\" name=\"ADS_ACTION[DELETE]\" value=\"".__('Delete','ads-wordpress')."\" />";
        }
        if($return)  return $html;
        else echo $html;
    }
    /*
    	устанавливает статус записи
    */
    function set_status(){
        global $user_ID, $ads_options;
        if(current_user_can( 'edit_others_posts', $user_ID )){ // если у юзера права редактора
            if($this->action == 'PUBLISH' OR  $this->action == 'UPDATE')
                $_REQUEST['post_status'] =  'publish';
            elseif($this->action == 'SAVE')
                $_REQUEST['post_status'] =  'draft';
        }
        elseif( current_user_can( 'edit_posts', $user_ID ) ) // просто автор
            if($ads_options['ads_post_status'] == 'publish'){
                if($this->action == 'PUBLISH' OR  $this->action == 'UPDATE')
                    $_REQUEST['post_status'] =  'publish';
                elseif($this->action == 'SAVE')
                    $_REQUEST['post_status'] =  'draft';
            }elseif($ads_options['ads_post_status'] == 'pending'){
                if($this->action == 'PUBLISH' OR  $this->action == 'UPDATE')
                    $_REQUEST['post_status'] =  'pending';
                elseif($this->action == 'SAVE')
                    $_REQUEST['post_status'] =  'draft';
            }else{
                $_REQUEST['post_status'] =  'draft';
            }
        else{
            // если нет то статус устанавливаем в соответствии с настройками плагина
            $_REQUEST['post_status'] = $ads_options['ads_post_status'];
        }
        //echo '<pre>set_status():'; print_r($this->action.' => '.$_REQUEST['post_status']); echo '</pre>';
    }
    /*
    	устанавливает статус комментариев для записи
    */
    function set_comments(){
        global $ads_options;

    	if(($ads_options['ads_comments']) == 'optional') {
    		$_REQUEST['comment_status'] = ($_REQUEST['comment_status']) ? 'open' : 'closed';
    	}
    	else {
    		$_REQUEST['comment_status'] = $ads_options['ads_comments'];
    	}

    }
    /*
    	устанавливает ads_basecat - базовую категорию объвления
    */
    function set_basecat(){
        global $ads_options;
       	if(!(int)$_REQUEST['ads_basecat']){
            if($ads_options['ads_base_category'])
    			$_REQUEST['ads_basecat'] = $ads_options['ads_base_category'];
    		else
    		    $_REQUEST['ads_basecat'] = get_option('default_category');
    	}
    }

    function set_category(){
        global $ads_options;
        if($_REQUEST['ads_old_categories'] AND $ads_options['ads_overdue_category'] AND $ads_options['ads_restore']){
           $categories = get_post_meta($_REQUEST['ID'],'ads_old_categories',1);
           if( $categories){
                wp_delete_object_term_relationships($_REQUEST['ID'], array('category'));
                $_REQUEST['post_category'] = array_merge($categories,array($_REQUEST['ads_basecat']));
                delete_post_meta($_REQUEST['ID'], 'ads_old_categories');
                unset($_REQUEST['ads_old_categories']);
           }
        }
        if(sizeof($_REQUEST['post_category']))
            $_REQUEST['post_category'] = array_merge($_REQUEST['post_category'],array($_REQUEST['ads_basecat']));
        else
            $_REQUEST['post_category'] = array($_REQUEST['ads_basecat']);
    }

    function set_date(){
        global $ads_options;
        if($ads_options['ads_change_date']){
            $_REQUEST['post_date']  = current_time('mysql');
            $_REQUEST['post_date_gmt'] = '';
        }
    }

    function set_post_type(){
        global $ads_options;
        if($ads_options['ads_post_type_name']){
            $_REQUEST['post_type'] = $ads_options['ads_post_type_name'];
        }else{
            $_REQUEST['post_type'] = 'post';
        }
    }

    /*
      сохранение данных
    */
    function save_form(){
        $this->set_user_post();
        $this->set_comments();
        $this->set_basecat();
        $this->set_category();
        $this->set_date();
        $this->set_post_type();
        //  отключаем ревизии  pre_post_update wp_save_post_revision
        remove_action('pre_post_update', 'wp_save_post_revision');
        //  подключаем фитр для добавления полей adp_
        add_filter('wp_insert_post_data','ads_table_fields',10,2);
        if((int)$_REQUEST['ID'] ){
            // проверяем может ли пользователь редактировать запись
            if($this->can_edit() AND get_post($_REQUEST['ID']) ){
                wp_delete_object_term_relationships($_REQUEST['ID'], array('post_tag'));
                wp_delete_object_term_relationships($_REQUEST['ID'], array('category'));
                $ads_ID = wp_update_post($_REQUEST);
                if( $ads_ID != $_REQUEST['ID'] ) {
                    $this->wp_error->add('save_form', __('Error in save_form() -> wp_update_post().'));
                    $_REQUEST['post_status'] = get_post_status($_REQUEST['ID']); // возвращаем статус в исходное положение
                    return false;
                } else{
                    $_SESSION['ads_posts_edit'][$ads_ID][] =  time();
                }
            } else {
                $this->wp_error->add('save_form', __('Error in save_form() -> wp_update_post() do not update post.'));
                $_REQUEST['post_status'] = get_post_status($_REQUEST['ID']); // возвращаем статус в исходное положение
                return false;
            };
        }else{  // новый пост
            if(!$this->can_new_post())  return false;

            $ads_ID = wp_insert_post( $_REQUEST, 1 );
            if(is_wp_error($ads_ID) ) {
                $this->wp_error = $ads_ID;
                $_REQUEST['post_status'] = '';
                return false;
            }else {
                $_REQUEST['ID'] = $ads_ID;
                $_REQUEST['ads_password'] = genPassword();
                $_REQUEST['ads_IP'] = getip();
                $_REQUEST['post_type'] = 'ads';
                $this->NEW_POST = true;
                $_SESSION['ads_posts_edit'][$ads_ID][] =  time();
    		    $_SESSION['last_post'] = time();
            }
        }
        //http://wp29/?p=164&preview=true
        $this->save_meta();
        //$this->print_msg('saved');
        return $ads_ID;
    }


    function  download_file( &$attachments ){
        if( function_exists('stream_context_create')){
            $opts = array(
              'http'=>array(
                'method'=>"GET",
                'header'=>"Accept-language: {$_SERVER['HTTP_ACCEPT_LANGUAGE']}\r\n" .
                          "Cookie: {$_SERVER['HTTP_COOKIE']}\r\n" .
                          "User-Agent: {$_SERVER['HTTP_USER_AGENT']}\r\n"
              )
            );
           $context = stream_context_create($opts);
        }
        foreach ($_REQUEST['ads_files'] as $key=>$url) {
            if(!$url OR isset($attachments[$key]) OR $_FILES[$key]['size'] ) continue;
            $file = file_get_contents($url, false, $context);
            $tmp_dir = get_cfg_var("upload_tmp_dir");
            $tmpfname = tempnam($tmp_dir, "ads_");
            $handle = fopen($tmpfname, "w");
            fwrite($handle, $file);
            fclose($handle);
            if( $type = mime_content_type ( $tmpfname ) ) {
    			list($type,$binary) =  explode(';', $type);

    		}
            else {
    			$type = wp_check_filetype($tmpfname);
    			$type = $type['type'];
    		}
    		$suffix = str_replace('/', '.', strrchr($type,'/') );
    		if( ! preg_match("|\.([a-z0-9]{2,4})$|i", basename($url) ) ){
    			$url .= $suffix;
    			rename ($tmpfname, $tmpfname.$suffix);
    			$tmpfname = $tmpfname.$suffix;
    		}

            $_FILES[$key] = array(
                'name'=>  basename($url),
                'type' => $type,
                'tmp_name' => $tmpfname,
                'size' => filesize($tmpfname),
                'error' => 0
            );
        }
    }
    /*
    	загружаем загрузки
     Array
            (
                [name] => 12743803594.jpg
                [type] => image/jpeg
                [tmp_name] => S:\tmp\php25C.tmp
                [error] => 0
                [size] => 143934
            )
    */
    function set_draft(){
        if((int)$_REQUEST['ID']){
           $args =  array( 'ID' => $_REQUEST['ID'], 'post_status' =>  'draft');
           $new_ID = wp_update_post( $args );
           $_REQUEST['post_status'] =  'draft';
           $this->wp_error->errors['post_status'][] = __('<b>Post Save as Draft! Update it!</b>','ads-wordpress');
        }
    }
    function upload(){
        global $ads_options;
        include_once(ABSPATH . '/wp-admin/includes/image.php');
        include_once(ABSPATH . '/wp-admin/includes/media.php');
        include_once(ABSPATH . '/wp-admin/includes/file.php');

        $attachments = $this->get_attachments();
        if(sizeof($_REQUEST['ads_files'])) $this->download_file( &$attachments );
        $_FILES = apply_filters('ads_check_files', $_FILES, &$attachments, &$this);
        if($_FILES['error']){

            $this->wp_error->errors =  $_FILES['error'];
            // если запись уже создана переключаем стату в черновик поскольку были ошибки в файлах
            $this->set_draft();

        }

        if( !sizeof($_FILES) OR !$ads_options['ads_count_upload'] ) return;


        $ads_max_size = floatval($ads_options['ads_max_size'])  * 1024 * 1024;
        $ads_max_img_x  = $ads_options['ads_max_img_x'];
        $ads_max_img_y  = $ads_options['ads_max_img_y'];
        for ($key = 0; $key < $ads_options['ads_count_upload']; $key++) {
            if($_FILES['error']['upload_error'][$key]) continue;
            if($_FILES[$key]['size'] > 0 AND !isset($attachments[$key]) ){
                if($ads_max_size AND ($ads_max_size < $_FILES[$key]['size']) ){
                    $this->wp_error->errors['upload_error'][$key]  =  __("Upload error: exceeded the maximum file size!",'ads-wordpress');
                }
                elseif(!ads_check_type_file($_FILES[$key]['type']))
                    $this->wp_error->errors['upload_error'][$key]  =  __("Upload error: prohibited file type!",'ads-wordpress');

                else
                    $_files[$key] = $_FILES[$key];

                //  обрезка больших фото
                if((int)$ads_max_img_x and (int)$ads_max_img_y){
                    list($orig_w, $orig_h, $orig_type) = $arr = getimagesize( $_files[$key]['tmp_name'] );
                    if( ($ads_max_img_x < $orig_w) or ($ads_max_img_y<$orig_h) ){
                        $new_file = image_resize( $_files[$key]['tmp_name'], $ads_max_img_x, $ads_max_img_y);

                        if($new_file){
        					unlink($_files[$key]['tmp_name']);
        					rename($new_file,$_files[$key]['tmp_name']);
        				}
                    }
                }
            }
        }

        if(!sizeof($_files)) return false;

        // если запись не созданна создаем черновик  с заголовком записи ads_draft
        if(!(int)$_REQUEST['ID']){
            if(!$this->can_new_post())  return false;

            $ads_ID = wp_insert_post( array('post_title'=>'ads_draft','post_status'=>'draft'), 1 );
            if(is_wp_error($ads_ID) ) {
                $this->wp_error = $ads_ID;
                $_REQUEST['post_status'] = '';
                return false;
            }

            $_REQUEST['ID'] = $ads_ID;
            $_REQUEST['post_status'] =  'draft';
            $_REQUEST['ads_password'] = genPassword();
            $this->NEW_POST = true;
            $_SESSION['ads_posts_edit'][$ads_ID][] =  time();
    	    $_SESSION['last_post'] = time();
    	    $this->save_meta();
        }
        foreach ($_files as $key=>$file) {
            $file_id = media_handle_sideload($_files[$key], $_REQUEST['ID'], '' ,array('menu_order'=>$key) );
            if(is_wp_error($file_id) ) {
                $error =  implode( "\n", $file_id->get_error_messages());
                $this->wp_error->errors['upload_error'][$key] = $error;
            }

        }
    }

    function set_thumbnail(){
        global $ads_options;
        $num = $ads_options['ads_set_thumbnail'] - 1;
        $attachments = $this->get_attachments();
        if($attachments[$num]){
            set_post_thumbnail( $_REQUEST['ID'], $attachments[$num]['ID'] );
        } else {
           delete_post_meta($_REQUEST['ID'], '_thumbnail_id');
        }
    }

    function get_attachments(){
        global $wpdb;
        if(!$_REQUEST['ID']) return false;
        $query = "SELECT $wpdb->posts.* FROM $wpdb->posts WHERE  ($wpdb->posts.post_parent = {$_REQUEST['ID']})  AND $wpdb->posts.post_type = 'attachment'";
        $tmp_wpdb = new wpdb(DB_USER, DB_PASSWORD, DB_NAME, DB_HOST);
        $arr = $tmp_wpdb->get_results($query,ARRAY_A);
    	if(!$arr) return false;
        foreach ($arr as $key=>$atach) {
            $metadata =  wp_get_attachment_metadata($atach['ID']);
            $order =  $atach['menu_order'];
            $files[$order] = $atach;
            if(wp_attachment_is_image($atach['ID'])){
                $files[$order]['thumbnail'] = wp_get_attachment_thumb_url( $atach['ID']);
            }else{
                $files[$order]['thumbnail'] = wp_mime_type_icon( $atach['ID'] );
            }
        }
        return  $files;
    }

    /*
    	поворот картинки
    */
    function file_rotate(){
    	$atach_ID = @key($_REQUEST['ADS_ACTION'][$this->action]);
    	if(!(int)$atach_ID) {
    		$this->wp_error->add('file_delete', __('Error, no atacment ID!','ads-wordpress'));
    		return false;
    	}
    	$attachment = get_post($atach_ID);
    	if($attachment->post_parent == $_REQUEST['ID']){
            if( function_exists('imagerotate')) {
                if($this->action == 'ROTATE_LEFT') $ugol = 90;
                else $ugol = -90;
                $res = wp_get_attachment_metadata($atach_ID);
                $uploads_dir = wp_upload_dir('baseurl');
                $file = $uploads_dir['basedir'].'/'.$res['file'];
                $file_dir = dirname($file);
                foreach ($res['sizes'] as $key=>$value) {
                    unlink($file_dir.'/'.$value['file']);
                }
        		include_once(ABSPATH . '/wp-admin/includes/image.php');
        		$source = @imagecreatefromjpeg($file);
        		$rotate = imagerotate($source, $ugol, 0);
        		imagejpeg ($rotate , $file);
        		return wp_update_attachment_metadata( $atach_ID, wp_generate_attachment_metadata( $atach_ID, $file ) );
        	}
        	else {
        		$this->wp_error->add(__("The function imagerotate() is not supported.",'ads-wordpress'));
        		return false;
        	}
    	} else {
    		$this->wp_error->add('file_delete', __('Error, post_parent not file does not match the current record!','ads-wordpress'));
    		return false;
    	}
    }
    /*
    	удаляет файл (загрузку)
    */
    function file_delete(){
    	$atach_ID = @key($_REQUEST['ADS_ACTION'][$this->action]);
    	if(!(int)$atach_ID) {
    		$this->wp_error->add('file_delete', __('Error, no atacment ID!','ads-wordpress'));
    		return false;
    	}
    	$attachment = get_post($atach_ID);

    	if($attachment->post_parent == $_REQUEST['ID']){
    		$res = wp_delete_attachment($atach_ID);
    		if(is_wp_error($ads_ID) ) {
    			$this->wp_error = $res;
    			return false;
    		}
    		return $res;
    	} else {
    		$this->wp_error->add('file_delete', __('Error, post_parent not file does not match the current record!','ads-wordpress'));
    		return false;
    	}
    }


    /*
    	отсылает почту
    */
    function send_mail(){
        global $ads_config,$ads_options;

        if(!($_REQUEST['ads_email'] OR $ads_options['ads_notice_admin']) ) return;
        if($this->NEW_POST){
            if(!$ads_options['ads_email_new_post']) return;
            $template = $ads_config['email_new_post'];
        } else{
            if(!$ads_options['ads_email_edit_post']) return;
            $arr_saves = $_SESSION['ads_posts_edit'][$_REQUEST['ID']];
             $save_last = array_pop($arr_saves);
            $cave_penult  = array_pop($arr_saves);
            // повторное подтверждение отсылается если если разница
            // между редакциями по времени более 15 мин
            if( ($save_last - $cave_penult) < 90) return;
            $template = $ads_config['email_edit_post'];

        }
        extract($_REQUEST);
        $ads_email = ($ads_email) ? $ads_email.','.$ads_options['ads_notice_admin'] : $ads_options['ads_notice_admin'];
        $ads_password = $_REQUEST['ID'].'.'.$ads_password;
        $title = __('Notice from ','ads-wordpress'). get_bloginfo( 'url' );
        $urlEdit = get_bloginfo('wpurl').'/?page_id='.$ads_options['ads_edit_page'].'&ADS_ACTION[LOGIN]=1&ads_password='.$ads_password;
        $urlDelete = get_bloginfo('wpurl').'/?page_id='.$ads_options['ads_edit_page'].'&ADS_ACTION[LOGIN_DELETE]=1&ads_password='.$ads_password;
        $postUrl = get_permalink($postID);

      	ob_start();
    	include_once($ads_config['dir_template'].$template);
    	$message = ob_get_contents();
    	ob_end_clean();
        $message .= "\n " . __("Plugin Ads WordPress from http://ili.com.ua/wordpress/ads-wordpress ",'ads-wordpress');
        wp_mail($ads_email,$title, $message);
    }


    /*
    	заменяет автора сообщени на то что указано в опциях
    */
    function set_user_post(){
        global $user_ID, $ads_options;
    	if(!$user_ID and $ads_options['ads_user_id']) {
    	     $_REQUEST['post_author'] = $ads_options['ads_user_id'];
    	}
    }
    /*
    	пишет сообщение

    */
    function print_msg($code){

        switch ($code) {
            case 'saved':
                $preview_link = add_query_arg('preview', 'true', get_permalink($_REQUEST['ID']) );
    ?>
    <div align='right' id="ads_info">
        <span id="ads_info_succes"><?_e('Your entry №','ads-wordpress')?> <b><?=$_REQUEST['ID']?></b> <?_e('is edited successfully.','ads-wordpress')?></span>
        <br />
        <span id="ads_info_password"><nobr><?_e('Password:','ads-wordpress')?>  <u><b><?=$_REQUEST['ID'].'.'.$_REQUEST['ads_password']?></b></u>;</nobr></span>
        <span id="ads_info_status"><nobr><?_e('Status:','ads-wordpress')?> <b><?_e($_REQUEST['post_status'],'ads-wordpress')?></b>;</nobr></span>
        <span id="ads_info_preview">
        <?if($_REQUEST['post_status']=='publish'):?>
        <a href='<?=$preview_link?>' target='_blank'><?_e('Review','ads-wordpress')?></a>
        <?else:?>
        <a href='<?=$preview_link?>' target='_blank'><?_e('Preview','ads-wordpress')?></a>
        <?endif;?>
        </span>
    </div>
    <?
            break;
            case 'no_new_post':
    ?>
    <font color="#FF0000" size="2"><?=implode( "\n", $this->wp_error->get_error_messages() ) ?></font><br />
    <?
            break;
            default:
        	   echo __('empty message?','ads-wordpress');
        	break;
        }
    }
    /*
    	проверяет может ли пользователь создатть новую запись
    	проверяем интервал сообщений
    */
    function can_new_post(){
    	global $ads_options,$user_ID;
    	 if(current_user_can( 'edit_others_posts', $user_ID )) return true;
    	$timeInterval = (real)$ads_options['ads_interval']*3600;
    	if(!$timeInterval) $timeInterval = 300;
    	if( ( time() - $_SESSION['last_post'] ) < $timeInterval ) {
    		$ostTime = $timeInterval - ( time() - $_SESSION['last_post']);
    		$min = floor($ostTime / 60);
    		$sec = $ostTime % 60;
    		$hors = floor($min/60);
    		$min = $min % 60;
    		$this->wp_error->add('can_new_post', sprintf (__("Sorry, you can write next entry after %d hours %d min %d sec. <br /><a target='_top' href = './'>Home page</a>",'ads-wordpress'),$hors,$min,$sec) );
    		return false;
    	}
    	return true;
    }
    /*
    	функция проверяет возможность удаления поста
    */
    function  can_delete(){
        global $user_ID;
        if($user_ID){
            if(user_can_delete_post($user_ID, $_REQUEST['ID']))
                return true;
            else{
                $this->wp_error->add('can_delete', __('Error, You do not delete this entry!','ads-wordpress'));
                return false;
            }
        }else{
            $ads_password = get_post_meta($_REQUEST['ID'], 'ads_password', 1);
            if( $ads_password AND ($ads_password == $_REQUEST['ads_password']) )
                return true;
            else {
                $this->wp_error->add('can_delete', __('Error, incorrect password or ID, do not delete this entry!','ads-wordpress'));
                return false;
            }
        }
    }

    /*
    	судя по названию удаляет запись со всеми причендалами
    */

    function to_trash(){
        global  $ads_options;
        if(!(int)$_REQUEST['ID']) {
            $this->wp_error->add('delete',  __('No delete - empty post ID!', 'ads-wordpress') );
            return false;
        }
        $post_id = $_REQUEST['ID'];
        if( $this->AdsFormEdit AND ($ads_options['ads_overdue_category'] OR $ads_options['ads_overdue_metafield'])) {
            // устанавливаем метаполе тип просроченно = текущему времени
            if($ads_options['ads_overdue_metafield']){
                if(update_post_meta($post_id, 'ads_overdue', time() ) )
                    echo "<b>ID:</b> $post_id - ".__('post is marked as not active','ads-wordpress')."<br />";
                else
                 echo "<b>ID:</b> $post_id - ".__('error when deactivating','ads-wordpress')."<br />";

            }
            if($ads_options['ads_overdue_category']){
                $old_categories =  wp_get_post_categories( $post_id);
                update_post_meta($post_id, 'ads_old_categories', $old_categories );
                wp_delete_object_term_relationships($post_id, array('category'));
                $categories = explode(',',$ads_options['ads_overdue_category']);
                if(wp_set_post_categories($post_id,$categories))
                   echo "<b>ID:</b> $post_id - ".__('post moved to a special category','ads-wordpress')."<br />";
                else
                echo "<b>ID:</b> $post_id - ".__('error when changing categories','ads-wordpress')."<br />";
            }
            delete_post_meta($post_id, 'ads_lifetime');
        }else{
            $arrTmp = get_children(array('numberposts'=>-1, 'post_type'=>'attachment','post_status'=>'inherit', 'post_parent'=>$post_id));
    		$arrTmp[$post_id] = '';
    		foreach ($arrTmp as $key=>$value) {
      			$post = wp_delete_post($key,1);
      			$title = ($post->post_title)?$post->post_title:$post->post_name;
                $msg = ($post)?'Deleted':'Error';
              	echo "<b>ID:</b> $post->ID;  <b>type:</b> $post->post_type;  <b>name:</b>  $title - $msg. <br />";
            }
        }
    }

   function delete(){
         global  $ads_options;
        if(!(int)$_REQUEST['ID']) {
            $this->wp_error->add('delete',  __('No delete - empty post ID!', 'ads-wordpress') );
            return false;
        }
        $defaults = array(
    		'numberposts' => -1, 'post_type' => 'any',
    		'post_status' => 'any', 'post_parent' => $_REQUEST['ID'],
    	);
    	$arr_delete = get_posts($defaults);
        $post =  get_post($_REQUEST['ID']);
        $arr_delete[] = $post;

        krsort ($arr_delete);
        reset ($arr_delete);
    	foreach ($arr_delete as $key=>$post) {
    		$res = wp_delete_post($post->ID,1);
            $title = ($post->post_title) ? $post->post_title : $post->post_name;
            $msg = ($res)?'Delete':'Error';
    		echo "<b>ID:</b> $post->ID;  <b>type:</b> $post->post_type;  <b>name:</b>  $title - $msg. <br />";
    	}
    }


    /*
    	проверяет может ли пользователь редактировать запись
    */
    function can_edit(){
        global $user_ID;
        if($user_ID){
            if(user_can_edit_post($user_ID, $_REQUEST['ID']))
                return true;
            else{
                $this->wp_error->add('can_edit', __('Error, You do not edit this entry!','ads-wordpress'));
                return false;
            }
        }else{
            $ads_password = get_post_meta($_REQUEST['ID'], 'ads_password', 1);
            if( $ads_password AND ($ads_password == $_REQUEST['ads_password']) )
                return true;
            else {
                $this->wp_error->add('can_edit', __('Error, incorrect password or ID, do not edit this entry!','ads-wordpress'));
                return false;
            }

        }
    }
    /*
    	сохраняет мета поля  с ads_
    	в таблица
    */
    function save_meta(){
        global $ads_options;
        // востановление объвления из корзины
        if($_REQUEST['ads_overdue'] AND $ads_options['ads_restore'] ){
            delete_post_meta($_REQUEST['ID'], 'ads_overdue');
            unset( $_REQUEST['ads_overdue']);
        }
        if(!$_REQUEST['ID']) return false;
    	foreach ($_REQUEST as $key=>$value) {
    	   if( strpos($key,'ads_')===0 ) {
        		if(get_post_meta($_REQUEST['ID'], $key)){
        		    if(empty($value)) delete_post_meta($_REQUEST['ID'], $key);
        		    else  update_post_meta($_REQUEST['ID'], $key, $value);
        		}else{
                     if(!empty($value)) add_post_meta($_REQUEST['ID'], $key, $value);
        		};
    	   }
    	}
    	return true;
    }
    /*

    Returns form template in accordance with the category
    line is set in a config.php form_templates
    If the category template is not defined
    checks whether the category of descendants if there are prints sublayer
    and nourish false
    if no descendants return to the default template
    */
    function category_template($base_category = 0){
        global $ads_config, $ads_options;
        $opt_basecat = $ads_options['ads_base_category'];
        $ads_exclude = $ads_options['ads_exclude'];
        extract($ads_config, EXTR_SKIP);
        $form_templates = $ads_config['form_templates'];
        // получаем масив родителей категории
        if($base_category AND ($base_category!=$opt_basecat) )
            $arr_parent = ads_get_parents_id($base_category);
        // проверяем чтобы категория не содержалась в списке  $ads_exclude  и не была одним из потомков
        // категории этого списка
        if($ads_exclude AND $arr_parent){
            $arr_exclode = explode(',',trim($ads_exclude));
            foreach ($arr_exclode as $key=>$value) {
            	$arr_exclode[$key] = trim($value);
            }
            $res = @array_intersect($arr_parent, $arr_exclode);
            if( sizeof($res) )  {
                $this->wp_error->add( 'ads_main', __("Error: ads_basecat category within the list of exceptions!",'ads-wordpress') );
                return false;
            }
        }

        if((int)$opt_basecat AND $arr_parent AND !@in_array($opt_basecat,$arr_parent) ){
            $this->wp_error->add( 'ads_main', __("Error: ads_basecat category is not a descendant of the basic categories!",'ads-wordpress') );
            return false;
        }

        if($form_templates['all']) return $form_templates['all'];
        if($base_category)
            $category = get_category($base_category);
        else
            $category = get_category($opt_basecat);

        if(isset($form_templates[(int)$opt_basecat])) return $form_templates[$opt_basecat];
        if(isset($form_templates[(int)$base_category])) return $form_templates[$base_category];
        if(isset($form_templates[$category->name])) return $form_templates[$category->name];
        if(isset($form_templates[$category->slug])) return $form_templates[$category->slug];

        if($base_category)
            $categories = get_categories(array('child_of' =>$base_category, 'hide_empty'=>0,'exclude'=>$ads_exclude));
        elseif($opt_basecat)
            $categories = get_categories(array('child_of' =>$opt_basecat,'hide_empty'=>0,'exclude'=>$ads_exclude));
        else
            $categories = get_categories(array('hide_empty'=>0,'exclude'=>$ads_exclude ));
        if(sizeof($categories)<2){
            unset($categories);
    		return $form_templates['default'];
        }
     	return false;
    }

    /*
    	проверка вводимых данных
        общий принцип  - если проверка пойдена возращаем true иначе false
        ошибки записываем в $this->error
    */
    function check_form(){

        $_REQUEST = apply_filters('ads_check_fields', $_REQUEST, & $this);

        if($_REQUEST['error']){
            if( is_array($_REQUEST['error']) ) {
                foreach ($_REQUEST['error'] as $key=>$error) {
                    $this->wp_error->errors[$key] = (is_array($error)) ? $error : array($error);
                }

            }
            else $this->wp_error->errors['main'][] = $_REQUEST['error'];
        }
        if(!($_REQUEST['post_content'] OR $_REQUEST['post_title'])){
    		$this->wp_error->add( 'ads_main', __("Error: Enter the text of announcement or title!",'ads-wordpress') );
        }
        if(!$this->name_template) $this->wp_error->add( 'ads_main', __("Error: mismatch base category!",'ads-wordpress') );

     	$this->check_ifetime();
    	$this->check_set_tags();

        if(sizeof($this->wp_error->errors)) return false;
        return true;
    }


    /*
    	обрабатывает метки для запси
    	массив ar_tags - не обрабатываеца
    	а строка tags_input  - проверяеца  максимальное кол-во тегов 5
    	без запрещенных символов и не длинее 26 символоа
    */
    function check_set_tags(){
    	global $ads_options;
    	// метки                    1
      	if($_REQUEST['ar_tags']){
           $_REQUEST['tags_input'] = $_REQUEST['ar_tags'];
    	}
    	elseif($_REQUEST['tags_input'] AND $ads_options['ads_user_tags']){
            if(preg_match( '~,~',$_REQUEST['tags_input']))
                $arrTags = explode( ',', trim($_REQUEST['tags_input'], " \n\t\r\0\x0B,")                  );
            else
                $arrTags[] = $_REQUEST['tags_input'];
            if(sizeof($arrTags) > 5){
               $this->wp_error->add( 'tags_input', __("Error:",'ads-wordpress')." ($tag) - ".__("no more than 5 tags!",'ads-wordpress'));
            }
            $xerna = '|['.preg_quote('`~!@#$%^&*()=+№{}<>?|:;"\'[]').']+|u';
            foreach ($arrTags as $tag) {
                if(preg_match($xerna,$tag)){
            		$this->wp_error->add( 'tags_input', __("Error: It the tag",'ads-wordpress')." ($tag) ".__("you can use only letters, digits and _",'ads-wordpress') );
                };
                if( preg_match('~.{26,}~u',$tag) ){
            		$this->wp_error->add( 'tags_input', __("Error:",'ads-wordpress')." ($tag) — ".__("tags no more than 25 symbols from comma to comma!",'ads-wordpress') );
                };

            }
    	}else{
    		unset($_REQUEST['tags_input']);
    	}

    }
    function check_ifetime(){
        if(isset($_REQUEST['ads_lifetime'])){
           if(empty($_REQUEST['ads_lifetime'])) unset($_REQUEST['ads_lifetime']);
           elseif(is_numeric($_REQUEST['ads_lifetime']) AND ($_REQUEST['ads_lifetime']>0) ){

           }else{
                $this->wp_error->add( 'ads_lifetime', __("Error: Period of the entry — incorrect format of the field!",'ads-wordpress') );
           }
        }
    }
    function error_msg($code='',$key = -1){
        if( $this->wp_error->errors[$code] )
            if($this->wp_error->errors[$code][$key])
                echo "<font class=\"ads_error\" color=\"#FF0000\">".$this->wp_error->errors[$code][$key]."</font>";
            else
                echo "<font class=\"ads_error\" color=\"#FF0000\">".implode("\n", $this->wp_error->errors[$code] )."</font>";
    }
    function get_url_captcha(){
        global $ads_config,$ads_options;
        if($_REQUEST['ID'] OR ($_REQUEST['ads_captcha'] AND ($_REQUEST['ads_captcha'] === $_SESSION['ads_captcha']) ) )
            return false;
        if($ads_options['ads_capthca'])
            return $ads_config['urlDir'].'ads_captcha.php?'.session_name().'='.session_id();
        return false;
    }

    /*
    	проверяет ввод каптчи или надоли ее вообще вводить
    если все хорошо возвернет труе
    */
    function  check_captcha(){
        global  $ads_options;

        if($_REQUEST['ID'] OR !$ads_options['ads_capthca']) return true;
        if($_REQUEST['ads_captcha'] AND ($_REQUEST['ads_captcha'] === $_SESSION['ads_captcha'])) return true;
        $this->wp_error->add( 'ads_captcha', __("Incorrect code from the picture!",'ads-wordpress') );
    }
    /*
    	если tags_input  - массив значит мы используем
    ar_tags самостоятельный ввод тегов через массив и
    tags_input  просто удаляем
    */
    function get_tags(){
    	if(is_array($_REQUEST['tags_input']))
    		unset($_REQUEST['tags_input']);
    }
    /*
    	печатет форму
    */
    function print_form(){
        global $ads_config, $ads_options;
        $url_captcha = 	$this->get_url_captcha();
        $this->get_tags();
        extract($ads_config, EXTR_SKIP);
    	extract($ads_options, EXTR_SKIP);
    	//
    	if(	$_REQUEST['comment_status'] == 'closed') unset($_REQUEST['comment_status']);
    	@extract($_REQUEST, EXTR_SKIP);
        if(is_wp_error($this->wp_error) ){
            $msg = implode( "\n", $this->wp_error->get_error_messages() );
            $msg = '<div class="ads_error">'.$msg.'</div>';
        }

        if($this->name_template) { //печатем форму
            // подготовим  ошибки для вывода
    		ob_start();
        	include $ads_config['dir_template'].$this->name_template;
        	$html_form = ob_get_contents();
        	ob_end_clean();
    		$ob = new HTML_FormPersister();
    		$_POST = $_REQUEST;
    		$html_form = $ob->process($html_form);
    		$html_form = $this->add_hidden_fields($html_form);
    		$html_form;
        }
        elseif(!$this->AdsFormEdit) { // если мы на стадии выбора категории то сбрасываем текущую сессию
            ob_start();
            include $ads_config['dir_template'].'/choice_category_template.php';
            $html_form = ob_get_contents();
        	ob_end_clean();
        }else{
            $html_form =  "<font color=\"#FF0000\" size=\"2\">$msg</font><br />";
        }

        $this->content = preg_replace('~<!--AdsForm[^>]*-->~i' , str_replace('\\0', '', $html_form), $this->content);
    }

    /*
    	загружает данные в $_REQUEST  массив
    */
    function load_data()
    {
        $load_post = get_post($_REQUEST['ID'],ARRAY_A);
        // загружаем мета поля
        $arrCustom = get_post_custom($_REQUEST['ID']);
        foreach ($arrCustom as $key=>$value) {
            $args[$key] = array_shift($value);
      	}
      	// загружаем теги
        if($arr = wp_get_post_tags($_REQUEST['ID'])){
            foreach ($arr as $key=>$value) {
               $arr2[] = $value->name;
            }
            $args['tags_input'] = implode(', ',$arr2);
            $args['ar_tags'] = $arr2;
        }

        // загружаем категориии
        $args['post_category'] = wp_get_post_categories($_REQUEST['ID']);

        $_REQUEST  = array_merge($load_post,$args);
    	// получаем текущий шаблон формы
        $this->name_template = $this->category_template($_REQUEST['ads_basecat']);
        return true;
    }
    /*
    проверяет коректность пользовательского пароля
    пароль состтоит из ID.ads_password  через точку
    устанавливает ID и  ads_password
    вариант 2 логинется если у паользователя есть права доступа к этой записи
    тоесть мы заходим по ссылке редактировать  $this->action == 'EDIT'
    */
    function ads_login(){
        global $user_ID;
        if(preg_match('~\d{1,6}\.[\d\w]+~i',$_REQUEST['ads_password'])){
            list($ads_ID,$ads_password) = explode('.',trim($_REQUEST['ads_password']));
            $get_password = get_post_meta($ads_ID, 'ads_password', 1);
            if($ads_password == $get_password){
                $_REQUEST['ID'] = $ads_ID;
                $_REQUEST['ads_password'] = $ads_password;
                return true;
            }
        }
        elseif(preg_match('~^\d+$~',$_REQUEST['ads_password']) AND user_can_edit_post($user_ID, (int)$_REQUEST['ads_password'])  ){
            $_REQUEST['ID'] = (int)$_REQUEST['ads_password'];
            return true;
        }
        elseif($this->action == 'EDIT'){
            if(!(int)$_REQUEST['ID']) $_REQUEST['ID'] = $_REQUEST['ADS_ACTION']['EDIT'];
            if(user_can_edit_post($user_ID, $_REQUEST['ID']))
                return true;
            else{
                $this->wp_error->add('save_form', __('Error, You do not edit this entry!','ads-wordpress'));
                return false;
            }
        }
        $this->wp_error->add('login', __("Incorrect  password, please, repeat data input.",'ads-wordpress'));
        return false;
    }
    /*
    	печатает форму входа для редактирования записи
    */
    function login_form(){
        global $ads_config, $ads_options;
        if(is_wp_error($this->wp_error) ){
            $wp_error = &$this->wp_error;
            $msg = implode( "\n", $wp_error->get_error_messages() );
        }
        include_once $ads_config['dir_template'].$ads_config['form_login'];
    }


    /*
    	дабавляет в обработаную форму скрытые поля
    	если есть ID записи то добаляется он
    */
    function add_hidden_fields($html_form){
        global $user_ID;
        if($_REQUEST['ID']){
            $hidden = '<input type="hidden" name="ID" value="'.$_REQUEST['ID']."\"/>\n";
            $hidden .= '<input type="hidden" name="ads_password" value="'.$_REQUEST['ads_password']."\"/>\n";
            if($this->AdsFormEdit){
                $hidden .= '<input type="hidden" name="ads_basecat" value="'.$_REQUEST['ads_basecat']."\"/>\n";
                if($ads_overdue = get_post_meta($_REQUEST['ID'],'ads_overdue',true) )
                    $hidden .= '<input type="hidden" name="ads_overdue" value="'.$ads_overdue."\"/>\n";
                if($ads_old_categories = get_post_meta($_REQUEST['ID'],'ads_old_categories', 1) )
                   $hidden .= '<input type="hidden" name="ads_old_categories" value="'.@implode(',', $ads_old_categories)."\"/>\n";
            }
            $hidden .= '</form>';
            $html_form = preg_replace('~</form>~i', $hidden , $html_form);
        }elseif(!empty($_SESSION['ads_captcha']) AND ($_REQUEST['ads_captcha'] === $_SESSION['ads_captcha']) ){
            $hidden = '<input type="hidden" name="ads_captcha" value="'.$_REQUEST['ads_captcha']."\"/>\n";
            $hidden .= '</form>';
            $html_form = preg_replace('~</form>~i', $hidden , $html_form);
        }

        return $html_form;
    }

    /*
    	отфильтровывает переменные которые не указаны в фильтре
    	работает напрямую с $_REQUEST
    */
    function filter_fields_form(){
    	foreach ($_REQUEST as $key=>$value) {
    			if(!in_array($key,$this->ads_fields_form)){
    					unset($_REQUEST[$key]);
    			}
    	}
    }

    /*
    	 комбинироует список-фильтр разрешонных полей из текущего сессии и ads_config.php
    	 и добавляет обязательные поля
    */
    function comb_fields_form(){
        global $ads_config;
        $_SESSION['ads_fields_form'] = @array_unique($_SESSION['ads_fields_form']);
        if($_SESSION['ads_fields_form'])
            $this->ads_fields_form  = array_merge($ads_config['ads_fields_form'], $_SESSION['ads_fields_form']);
        else
            $this->ads_fields_form  = $ads_config['ads_fields_form'];
    	//  список обязательных полей
        $default_fields  = array('ads_basecat', 'ads_password','ID','ADS_ACTION','ads_captcha','ads_files','ads_overdue','ads_old_categories');
        $this->ads_fields_form = array_merge($this->ads_fields_form, $default_fields );
        $this->ads_fields_form = array_unique ($this->ads_fields_form);
    }
    /*
    	если установленна опция $ads_user_status   только для зарегистрированных пользователей
    проверяет статус пользователя
    если все в порядке то вернет false !
    */
    function  check_user_status(){
        global $ads_options;
        if($ads_options['ads_user_status'] > 0){
           $wp_user = wp_get_current_user();
           if(!$wp_user->id ){
             return __("You are not authorized to access this page, you must register.",'ads-wordpress');
           }
        }
    }
} // END class ads_form_handler